#include<stdio.h>
#include<algorithm>
#include<vector>
using namespace std;
constexpr int MAX_N = 1'000'000;
int res[MAX_N+1];
 
inline int cmin(int x, int y){
    if(x<0)return y;
    if(y<0)return x;
    return min(x,y);
}
 
// n : box num, hi : height, hj : width small, hk : width big
//    (hi)
//     |BB
//    A|BBBB
//    A+------ (hk)
//   A/
//   /
// (hj)
//
// vhj : plane between i-j
// vhk : plane between i-k
 
int calculate(int cres, int base_value, int n, int hi, int hj, int hk, vector<int>& vhj, vector<int>& vhk)
{
    int i, j, k;
 
    // Phase 1 : Calculate plane side blocks first.
    // for(i=0;i<hi; i++){
    //     // i-j plane and i-k plane
    //     base_value += vhj[i];
    //     base_value += vhk[i];
    // }
    // // j-k plane without any blocks
    // base_value += hj + hk - 1;
 
    // printf("%d  %d %d %d  %d\n", n, hi, hj, hk, base_value);
    // for(i=0;i<hi;i++){
    //     printf("(%d, %d), ",vhj[i], vhk[i]);
    // }
    // printf("\n");
 
    // fast cut for exceed case.
    if(n <= 0){
        return base_value * 2;
    }
 
    vector<int> tower((hj-1)*(hk-1));
    int vhj_h = hi;
    for(j = 1; j < hj; j++){
        while(vhj_h>0 && vhj[vhj_h-1] <= j){
            vhj_h--;
        }
        int vhk_h = hi;
        for(k = 1; k < hk; k++){
            while(vhk_h>0 && vhk[vhk_h-1] <= k){
                vhk_h--;
            }
            tower[(j-1)*(hk-1) + (k-1)] = min(vhj_h, vhk_h);
        }
    }
 
    sort(tower.begin(), tower.end());
 
    // for(i=0;i<tower.size();i++){
    //     printf("%d, ",tower[i]);
    // }
    // printf("\n");
 
    int rem = n;
    int value = base_value;
    int ti = tower.size();
    while(rem > 0 && ti>0){
        rem -= tower[--ti];
        value++;
    }
 
    // printf(" -- rem : %d, value : %d\n", rem, value);
 
    if(rem > 0) return -1;
    return value * 2;
}
 
int build_vhk(int cres, int base_value, int n, int hi, int hj, int hk, vector<int>& vhj, vector<int>& vhk, int vhkdeps)
{
    if(vhkdeps == hi)
    {
        return calculate(cres, base_value, n, hi, hj, hk, vhj, vhk);
    }
    int curRes = -1;
    for(int i = 1; i <= vhk[vhkdeps - 1] && i <= n + 1; i++){
        if(cres <= (base_value + i + (hi - vhkdeps - 1))*2) break;
        vhk[vhkdeps] = i;
        curRes = cmin(curRes, build_vhk(cres, base_value + i, n - i + 1, hi, hj, hk, vhj, vhk, vhkdeps + 1));
    }
    return curRes;
}
int build_vhj(int cres, int base_value, int n, int hi, int hj, int hk, vector<int>& vhj, vector<int>& vhk, int vhjdeps)
{
    if(vhjdeps == hi)
    {
        return build_vhk(cres, base_value, n, hi, hj, hk, vhj, vhk, 1);
    }
    int curRes = -1;
    for(int i = 1; i <= vhj[vhjdeps - 1] && i <= n + 1; i++){
        if(cres <= (base_value + i + (hi - vhjdeps - 1) + hi - 1)*2) break;
        vhj[vhjdeps] = i;
        curRes = cmin(curRes, build_vhj(cres, base_value + i, n - i + 1, hi, hj, hk, vhj, vhk, vhjdeps + 1));
    }
    return curRes;
}
 
int process(int cres, int base_value, int n, int hi, int hj, int hk)
{
    vector<int> vhj(hi);
    vector<int> vhk(hi);
    vhj[0] = hj;
    vhk[0] = hk;
    return build_vhj(cres, base_value, n, hi, hj, hk, vhj, vhk, 1);
}
 
int main()
{
    //inil();
    int t;
    scanf("%d",&t);
    while(t--)
    {
        int n;
        scanf("%d",&n);
    {
        res[n] = 4 * n + 2;
        for(int i=1; i<=5 && i <= (n+2)/3; ++i){
            for(int j=i; i+j+j-2<=n; ++j){
                for(int k=j; i+j+k-2<=n; ++k){
                    int me = process(res[n], 2*(j + k) - 1, n - i - j - k + 2, i, j, k);
                    res[n] = cmin(res[n], me);
                }
            }
        }
        //printf("n : %d, res : %d\n", n, res[n]);
    }
        printf("%d\n",res[n]);
    }
}
